<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: Action names</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="page_References.html">References</a></li>  </ul>
</div>
</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Action names </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>The action names were introduced with two goals in mind: </p><ul>
<li>
To have a way of identifying individual UI elements (widgets) inside AS EWO for <a class="el" href="page_ConfigAdmin.html#sec_AccessControl">access control</a>.<br  />
 In 'usual' WinCC OA panel, CTRL code may access any control in this panel - for example, to set that control to 'disabled' state when current user has no rights to it.<br  />
 However, EWO is a single control in panel from CTRL code point of view, the rich/complex UI of EWO is hidden from CTRL code inside EWO's implementation. In order to control appearance of individual widgets <b>inside</b> EWO, CTRL code needs some mean to identify these widgets or EWO, like: 'I want to disable <b>button for acknowledging alarms</b>'.<br  />
 However, the CTRL code is not required to know which controls are used inside EWO for particular purpose, instead CTRL code shall need to know what <b>actions</b> can be initiated from inside EWO. Thus, CTRL code needs to address not he controls inside EWO, but rather actions which can be initiated from EWO. Then the request to EWO can be reformulated as following: 'I want to disable EWO control(s) which can initiate the <b>action</b> of alarm acknowledgedment'.  </li>
<li>
Many (really <b>many</b>) of actions arounf Alarm Screen functionality are easier to implement in CTRL code. However, most of these actions are initiated by user activation of widgets inside AS EWO. EWO has a standard way of notifying CTRL code in panel that something has happened (for example, user has clicked a abutton), that requires processing by CTRL code. Two extreme approaches can be considered: individual event of EWO for every control (widget) inside EWO; or single event of EWO with one of arguments for this event telling what exactly is requested. The second approach was used, with using action name as that 'what' argument, see "sAction" in description of AS EWO's <a class="el" href="page_RefEwo.html#sec_RefEwoEvents">events</a>.  </li>
</ul>
<p>The names of actions are declared as constants in CTRL library AlarmScreenNgActions.ctl: </p><ul>
<li>
<b>AS_EWO_ACTION_xxx</b>: names of actions initiated by controls (widgets) inside EWO </li>
<li>
<b>AS_ACTION_xxx</b>: names of actions initiated bu control in WinCC OA panels which part of this component&lt;/li&lt; </li>
</ul>
<p>The action namess in this section are not listed alphabetically, instead they are grouped around related UI elements.</p>
<h1><a class="anchor" id="sec_RefActionsSpecial"></a>
Special actions</h1>
<p>First of all, there are two special action names which serve only second goal of two, declared at the beginning of this part of document. These actions can't be disabled by means of access control. </p><table class="doxtable">
<tr>
<th>Action name </th><th>description  </th></tr>
<tr>
<td>basicConfigApplied </td><td>EWO's notification that new basic config was applied, CTRL code can perform any required processing that shal be done with 'ready to use EW'O, for example: load default user settings, connect EWO to all (or some) of systems etc.   </td></tr>
<tr>
<td>mouseEvent </td><td>This name is used in mouse event of AS EWO. CTRL code can disable execution of some (or all) of actions in response to mouse event, but firing the mouse event by EWO can't be disabled.   </td></tr>
<tr>
<td>oraclePassRequest </td><td>The request to decode password for ORACLE schema containing archived data. The encoded password is stored in dedicated DPE. When EWO receives new encoded string from DPE, the EWO fires event with this action and encoded password. In fact, this is a request to CTRL code asking to decode password.   </td></tr>
</table>
<h1><a class="anchor" id="sec_RefActionsAdmin"></a>
Admin Settings</h1>
<table class="doxtable">
<tr>
<th>UI elements </th><th>Action names  </th></tr>
<tr>
<td><div class="image">
<img src="actionAdminEwo.png" alt=""/>
<div class="caption">
Controls in AS EWO</div></div>
  </td><td>1:&#160;adminAccessControl<br  />
 2:&#160;adminPopupMenu<br  />
 3:&#160;adminOracleRdbSettings<br  />
 4:&#160;adminHelpFileTypes   </td></tr>
<tr>
<td><b>Apply</b> button in <a class="el" href="page_ConfigAdmin.html#sec_AccessControl">panel</a> for edidting Access Control rules </td><td>editAccessControl  </td></tr>
<tr>
<td><b>Apply</b> button in <a class="el" href="page_ConfigAdmin.html#sec_AdminPopupMenu">panel</a> for editing popup menu </td><td>editPopupMenu  </td></tr>
<tr>
<td><b>Apply</b> button in <a class="el" href="page_ConfigAdmin.html#sec_HelpFileTypes">panel</a> for editing the types of help files </td><td>editHelpFileTypes  </td></tr>
</table>
<h1><a class="anchor" id="sec_RefActionsAck"></a>
Alarm acknowledgement</h1>
<table class="doxtable">
<tr>
<th>UI elements </th><th>Action names  </th></tr>
<tr>
<td><div class="image">
<img src="actionAckEwo.png" alt=""/>
<div class="caption">
Controls in AS EWO</div></div>
  </td><td>1:&#160;ackMultiple<br  />
 2:&#160;ackSelected<br  />
 3:&#160;ackGone<br  />
 4:&#160;ackAll   </td></tr>
<tr>
<td><div class="image">
<img src="actionAckSingle.png" alt=""/>
<div class="caption">
Ack from Alarm Table</div></div>
  The user can click on cells in highlighted column in order to acknowledge alarm shown in this row. The clicking itself can't be disabled, AS EWO will fire corresponding event (see <a class="el" href="page_RefActions.html#sec_RefActionsSpecial">Special actions</a>), and CTRL code will process acknowledgement request. Furthermore, the AS EWO itself doesn't even know that clicking on this cell may result in alarm acknowledgement.<br  />
 But during processing CTRL code can check if the action is allowed for current user, if not - clicking will result in message like "You don't have permission..." instead of alarm acknowledgement. </td><td>ackSingle   </td></tr>
</table>
<h1><a class="anchor" id="sec_RefActionsUser"></a>
User settings</h1>
<table class="doxtable">
<tr>
<th>UI elements </th><th>Action names  </th></tr>
<tr>
<td><div class="image">
<img src="actionUserSettingsEwo.png" alt=""/>
<div class="caption">
Controls in AS EWO</div></div>
  </td><td>1:&#160;userSettings<br  />
 2:&#160;editUserSettings<br  />
 3:&#160;loadUserSettings<br  />
 4:&#160;saveUserSettings<br  />
 5:&#160;defaultUserSettings   </td></tr>
<tr>
<td><b>Delete</b> button in <a class="el" href="page_UserSettings.html">panels</a>, related to user settings operations. It is assumed that user can always delete his own settings, but deleting settings of another user requires special privilege </td><td>deleteUserSetting  </td></tr>
<tr>
<td><b>Apply</b> button in <a class="el" href="page_UserSettings.html#sec_UserSettingsSaveLoad">panel</a> nominating default user settings. Controls the ability of user to set selected user settings as 'Default for user' </td><td>setDefaultUserSettings  </td></tr>
<tr>
<td><b>Apply</b> button in <a class="el" href="page_UserSettings.html#sec_UserSettingsSaveLoad">panel</a> nominating default user settings. Controls the ability of user to set selected user settings as 'Default for all users' </td><td>setDefaultUserSettingsAll  </td></tr>
</table>
<h1><a class="anchor" id="sec_RefActionsSource"></a>
AlarmSource</h1>
<table class="doxtable">
<tr>
<th>UI elements </th><th>Action names  </th></tr>
<tr>
<td>The whole source control area (1) on the <a class="el" href="pageUsingAS.html#ewoOverviewPicture">picture</a>  </td><td>sourceControl   </td></tr>
<tr>
<td>Combo box used for selection of source type in <a class="el" href="pageUsingAS.html#ewoOverviewPicture">source control area</a> </td><td></td><td>switchSourceMode  </td></tr>
</table>
<h1><a class="anchor" id="sec_RefActionsFilter"></a>
Filters</h1>
<table class="doxtable">
<tr>
<th>UI elements </th><th>Action names  </th></tr>
<tr>
<td><div class="image">
<img src="actionFilterEwo.png" alt=""/>
<div class="caption">
Controls in AS EWO</div></div>
  </td><td>1:&#160;saveFilter<br  />
 2:&#160;loadFilter   </td></tr>
<tr>
<td><b>Delete</b> button in <a class="el" href="pageUsingAS.html#pictureSaveFilter">panel</a> for Save/Load operations with filters. It is assumed that user is always allowed to delete own filter, but deleting filter of another user requires special privilege.  </td><td>deleteFilter   </td></tr>
</table>
<h1><a class="anchor" id="sec_RefActionsFilterView"></a>
Filter View</h1>
<table class="doxtable">
<tr>
<th>UI elements </th><th>Action names  </th></tr>
<tr>
<td><div class="image">
<img src="actionFilterViewEwo.png" alt=""/>
<div class="caption">
Control in AS EWO</div></div>
   </td><td>editFilterSet  </td></tr>
<tr>
<td><b>New</b> button in <a class="el" href="page_FilterViewEditor.html">panel</a> for editing Filter View </td><td>createFilterSet  </td></tr>
<tr>
<td><b>Delete</b> button in <a class="el" href="page_FilterViewEditor.html">panel</a> for editing Filter View </td><td>deleteFilterSet  </td></tr>
</table>
<h1><a class="anchor" id="sec_RefActionsOther"></a>
Other actions</h1>
<table class="doxtable">
<tr>
<th>UI elements </th><th>Action names  </th></tr>
<tr>
<td><div class="image">
<img src="actionJcopMenu.png" alt=""/>
<div class="caption">
Default popup menu (JCOP)</div></div>
   </td><td>1.&#160;viewFSMPanel<br  />
 2.&#160;viewAlarmDetails<br  />
 3.&#160;viewAlarmTrend<br  />
 4.&#160;viewAlarmHelp<br  />
 5.&#160;viewAlarmComment<br  />
 6.&#160;toggleAlarmMasked <dl class="section note"><dt>Note</dt><dd>The appearance of last item in this menu is additionally controlled by <a class="el" href="page_RefJson.html#subsect_RefJsonBasicConfigSpecificOptions">specific option</a> in basic configuration   </dd></dl>
</td></tr>
<tr>
<td><div class="image">
<img src="actionExpandCollapse.png" alt=""/>
<div class="caption">
Popup menu for grouping columns</div></div>
 <div class="image">
<img src="actionExpandCollapse.png" alt="" width="4cm"/>
<div class="caption">
Popup menu for grouping columns</div></div>
 I'm wondering what was the reason for adding these actions. The menu items are processed inside EWO, without involving CTRL code. And I don't the reasons for resticting user access to these actions.  </td><td>1.&#160;expandAllNodes<br  />
 2.&#160;collapseAllNodes   </td></tr>
</table>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
